include \masm32\MasmBasic\MasmBasic.inc	; [url=http://www.masm32.com/board/index.php?topic=12460]download[/url]
FillArray	PROTO: SDWORD
qsc_proReal	PROTO
qsc_proRealBad	PROTO

.data
RealRangeLo	REAL8 -2222.2222
RealRangeHi	REAL8 2222.2222
DwRange=	200000
QwRange=	123456789
TestDesc=	0	; put 1 to test also the descending order

ShowOrder MACRO arg	; little macro for showing the sorted arrays
  if NumShow
	For_ ebx=0 To MaxIndex
		.if ebx<NumShow || ebx>MaxIndex-NumShow
			if arg eq TiDw()
				Print Str$(ebx), Str$("\t%i\n", TiDw(ebx))
			else
				Print Str$(ebx), Str$("\t%f\n", TiR8(ebx))
			endif
		.endif
	Next
  endif
ENDM
	Init
	MaxIndex=1000000
	Dim TiDw(MaxIndex) As DWORD
	Dim TiQw(MaxIndex) As QWORD
	Dim TiR4(MaxIndex) As REAL4
	Dim TiR8(MaxIndex) As REAL8
	PrintCpu
	NumShow = 0	; put e.g. 3 to see the first and last 5 sorted values, or 0 for no show
	REPEAT 3
		invoke FillArray, 1	; 1=load random numbers into DWORD array
		NanoTimer()
		ArraySort TiDw()
		Print Str$("%i ms for ArraySort+, Dword\n", NanoTimer(ms))
		ShowOrder TiDw()
		if TestDesc
			invoke FillArray, 1
			NanoTimer()
			ArraySort TiDw(-)
			Print Str$("%i ms for ArraySort-\n", NanoTimer(ms))
			Print
		endif
		invoke FillArray, 1
		NanoTimer()
		invoke nrQsortA, addr TiDw(0), MaxIndex+1
		Print Str$("%i ms for nrQsortA, Dword\n", NanoTimer(ms))
		ShowOrder TiDw()
		if TestDesc
			invoke FillArray, 1
			NanoTimer()
			invoke nrQsortD, addr TiDw(0), MaxIndex+1
			Print Str$("%i ms for nrQsortD\n", NanoTimer(ms))
		endif
		Print
	ENDM

	REPEAT 1
		invoke FillArray, 3	; 1=load random numbers into REAL8 array
		NanoTimer()
		ArraySort TiR8()
		Print Str$("\n%i ms for ArraySort+, Real8\n", NanoTimer(ms))
		NumShow=3
		ShowOrder TiR8()
		if TestDesc
			invoke FillArray, 3
			NanoTimer()
			ArraySort TiR8(-)
			Print Str$("%i ms for ArraySort-\n", NanoTimer(ms))
			ShowOrder TiR8()
		endif

		invoke FillArray, 3	; 1=load random numbers into REAL8 array
		NanoTimer()
		invoke crt_qsort, addr TiR8(0), MaxIndex+1, REAL8, qsc_proReal
		Print Str$("\n%i ms for CRT qsort,  Real8\n", NanoTimer(ms))
		ShowOrder TiR8()

		invoke FillArray, 3	; 1=load random numbers into REAL8 array
		NanoTimer()
		invoke crt_qsort, addr TiR8(0), MaxIndex+1, REAL8, qsc_proRealBad
		Print Str$("\n%i ms for CRT qsortB, Real8\n", NanoTimer(ms))
		ShowOrder TiR8()

		NumShow=0
		Print
	ENDM
	Inkey "ok"
	Exit
.code
FillArray proc uses ebx mode:SDWORD
  .if mode==1 || mode<0
	mov ebx, TiDw(?)
	.Repeat
		mov TiDw(ebx), Rand(DwRange)
		dec ebx
	.Until Sign?
	; PrintLine "DW filled"
  .endif
  .if mode==2 || mode<0
	mov ebx, TiR4(?)
	.Repeat
		Rand(RealRangeLo, RealRangeHi, TiR4(ebx))	; put random number into Real8 array
		dec ebx
	.Until Sign?
	; PrintLine "R4 filled"
  .endif
  .if mode==3 || mode<0
	mov ebx, TiR8(?)
	.Repeat
		Rand(RealRangeLo, RealRangeHi, TiR8(ebx))	; put random number into Real8 array
		dec ebx
	.Until Sign?
	; PrintLine "R8 filled"
  .endif
  .if mode==3 || mode<0
	mov ebx, TiQw(?)
	.Repeat
			Rand(0, QwRange, TiQw(ebx))
		dec ebx
	.Until Sign?
	; PrintLine "Qw filled"
  .endif
  ret
FillArray endp

qsc_proReal proc	; C arg1:DWORD,arg2:DWORD
	mov eax, [esp+4]	; arg1
	mov edx, [esp+8]	; arg2
	if 1
		ffree st(7)
		push eax
		fld REAL8 PTR [eax]
		fsub REAL8 PTR [edx]
		fmul FP8(1000.0)	; not a "durable" solution
		fistp stack
		pop eax
	elseif 1
		ffree st(7)
		ffree st(7)
		fldz
		fld REAL8 PTR [eax]
		fsub REAL8 PTR [edx]
		xor eax, eax
		fcomip ST, ST(1)	; should work but doesn't ;-)
		sbb eax, -1
		fstp st
	else
		movlps xmm0, REAL8 PTR [eax]	; fails miserably
		xor eax, eax
		comisd xmm0,  REAL8 PTR [edx]	; sets carry
		sbb eax, -1
	endif
	retn
qsc_proReal endp

qsc_proRealBad proc	; C arg1:DWORD,arg2:DWORD
	mov eax, [esp+4]		; arg1
	mov edx, [esp+8]		; arg2
	if 0
		ffree st(7)
		push eax
		fld REAL8 PTR [eax]
		fsub REAL8 PTR [edx]
		fmul FP8(1000.0)
		fistp stack
		pop eax
	else
		movlps xmm0, REAL8 PTR [eax]
		xor eax, eax
		comisd xmm0,  REAL8 PTR [edx]	; sets carry
		sbb eax, -1
	endif
	retn
qsc_proRealBad endp

end start

Intel(R) Celeron(R) M CPU        420  @ 1.60GHz (SSE3)
158 ms for ArraySort+, Dword
164 ms for nrQsortA, Dword

159 ms for ArraySort+, Dword
163 ms for nrQsortA, Dword

157 ms for ArraySort+, Dword
163 ms for nrQsortA, Dword


280 ms for ArraySort+, Real8
0       -2222.221
1       -2222.221
2       -2222.218
999998  2222.213
999999  2222.213
1000000 2222.222

570 ms for CRT qsort,  Real8
0       -2222.221
1       -2222.218
2       -2222.213
999998  2222.204
999999  2222.213
1000000 2222.215

55 ms for CRT qsortB, Real8
0       -1945.115
1       -1144.308
2       -686.3097
999998  2222.205
999999  2222.208
1000000 2222.213

OPT_Assembler	mlv615
OPT_Errline	0
OPT_Tmp2Asm	1
